<?php
/**
* SP FRAMEWORK FILE - DO NOT EDIT!
* 
* define the functions for database operations
******************************************************************/

/**
* get the data
*
******************************************************************/
function get_data() {
	global $wpdb, $themeinfo;
	
	$result = $wpdb->get_row("SELECT * FROM ".$wpdb->options." WHERE option_name = '".$themeinfo['Name']."_sp_data'");
	// must unserialize and decode
	$data = maybe_unserialize(base64_decode($result->option_value));
	
	// check if it is an array and if there are atleast 1 option record
	if (is_array($data) && count($data) >= 1) {
		// loop through the options as key/value pair
		foreach ($data as $name => $value) {
			$data[$name] = stripslashes($value);	
		}
	}
	return $data;
}

/**
* save the data
*
******************************************************************/
function save_data($data = array()) {
	global $wpdb, $themeinfo;
	// be sure to encode and serialize the data
	$result = $wpdb->query("UPDATE ".$wpdb->options." SET option_value = '".base64_encode(maybe_serialize($data))."' WHERE option_name = '".$themeinfo['Name']."_sp_data'");
	return $result;
}

/**
* initialize the database for the first time called by config
*
******************************************************************/
function init_db() {
	global $wpdb, $themeinfo;
	// check to see if data exists, if not create it
		if(!$wpdb->get_row("SELECT * FROM ".$wpdb->options." WHERE option_name = '".$themeinfo['Name']."_sp_data'")){
			$wpdb->query("INSERT INTO ".$wpdb->options." SET option_name = '".$themeinfo['Name']."_sp_data', option_value = '', autoload = 'yes'");

		/**
		* get theme specific config xml
		*
		******************************************************************/
			$file = fopen(TEMPLATEPATH.'/config.xml', 'r');
			$config = fread($file, filesize(TEMPLATEPATH.'/config.xml'));	
			fclose($file);
			$config = xml2array($config);
			$config = $config['config'];

			$data = array();
			if (is_array($config['tab'])) {
				foreach ($config['tab'] as $tabs) {
					foreach ($tabs['panel'] as $panels) {
						if (is_array($panels['wrapper'])) {
							foreach ($panels['wrapper'] as $wrappers) {
								if (is_array($wrappers['module'])) {
									foreach ($wrappers['module'] as $module) {
										$data[THEME_SHORTNAME.$module['_attr']['id']] = $module['_attr']['std'];
									}
								}
							}
						}
					}			
				}
				
			}
			$results = save_data($data);
			if ($results) {
			  update_option('single_view_image_height',sp_themeInit('wpec_single_view_image_size','height'));
			  update_option('single_view_image_width',sp_themeInit('wpec_single_view_image_size','width'));
			  update_option('product_image_height',sp_themeInit('wpec_product_image_size','height'));
			  update_option('product_image_width',sp_themeInit('wpec_product_image_size','width'));
			  update_option('wpsc_crop_thumbnails',sp_themeInit('wpec_image_crop','crop'));
			  
			  // set the default product gallery thumbnail size
			  update_option('wpsc_gallery_image_height',sp_themeInit('wpec_product_gallery_size','height'));
			  update_option('wpsc_gallery_image_width',sp_themeInit('wpec_product_gallery_size','width'));
			  
			  // set the default product group thumbnail size
			  update_option('category_image_height',sp_themeInit('wpec_product_category_size','height'));
			  update_option('category_image_width',sp_themeInit('wpec_product_category_size','width'));
			  
			  // set the default post thumbnail size
			  update_option('thumbnail_size_w',sp_themeInit('set_post_thumbnail_size','width'));
			  update_option('thumbnail_size_h',sp_themeInit('set_post_thumbnail_size','height'));
			  update_option('thumbnail_crop',sp_themeInit('set_post_thumbnail_size','crop'));
			  
			  // set the default WPEC pagination settings
			  update_option('use_pagination',sp_themeInit('wpec_pagination','enable'));
			  update_option('wpsc_products_per_page',sp_themeInit('wpec_pagination','per_page'));
			  update_option('wpsc_page_number_position',sp_themeInit('wpec_pagination','position'));
						  
			  // turn on add to cart for grid view
			  update_option("display_addtocart",sp_themeInit('wpec_gridview_addtocart','enable'));
				echo "done";
			}
		}
}

?>